\ INTRPRET.FFT                                                     03/05/98
\ =========================================================================
\
\ Der aeussere Interpreter
\
: KEY ( ps: ==> c )   CRX ;

: KEY? ( ps: ==> ? )  PAUSE CRX? ;

VARIABLE SPAN   SPAN  OFF   ( mit EXPECT gelesene Zeichen )

: DODEL  ( addr pos -- addr pos' )
   DUP IF  1 -  #BS CTX  BL CTX  BACKSPACE  THEN ;

: DECODE  ( addr pos1 key -- addr pos2 )
   ECHO @ IF   #BS CASE? IF  DODEL EXIT  THEN
               1 CASE? IF  OVER TIB - ?EXIT     \ input into TIB?
                           DUP #TIB @ < 0=EXIT  \ old input longer than new?
                           2DUP + >R   #TIB @ TUCK SWAP -
                           R> SWAP TYPE EXIT  THEN
   THEN      #CR CASE? IF  DUP SPAN ! ECHO @ 0=EXIT SPACE EXIT  THEN
   >R  2DUP +  R@ SWAP C!  1 +   R>  ECHO @ IF  EMIT EXIT  THEN  DROP; ;

: EXPECT  ( addr len -- )   \ 83,IO
   SPAN !   0
   BEGIN  KEY? UNTIL   RS232_SEMA LOCK
   BEGIN  DUP SPAN @ U< WHILE  KEY  DECODE  REPEAT
   RS232_SEMA UNLOCK   2DROP; ;

0128 CONSTANT TIB#                   \ maximale Zeichenanzahl im TIB

: QUERY ( -- )
   H_IO STREAM !   KEYBUF TIB# EXPECT
   SPAN @ #TIB !   KEYBUF SOURCE !   >IN OFF
;

CREATE KEYBUF SYS TIB# ALLOT  \ Terminal Input Buffer

     VARIABLE #TIB    #TIB OFF       \ aktuelle Zeichenanzahl im TIB
     VARIABLE SOURCE  KEYBUF SOURCE !

     VARIABLE >IN      >IN OFF      \ Pointer in aktuellen Quellstrom
     VARIABLE CAPS    CAPS ON

: TIB  ( -- addr )   SOURCE @; ;

CREATE TOKEN SYS  066 CHARS ALLOT ( Kettenpuffer fuer Interpret )
TOKEN OFF        \ initialize null string

CODE (PARSE) ( ps: c addr1 count2 ===> addr2 count2 count3  )
END-CODE

FALSE .IF                    Problemflle

"    DUP   "                 BL "P@ COUNT   (PARSE) CR ROT . SWAP . . "DROP
"      DUP "                 BL "P@ COUNT   (PARSE) CR ROT . SWAP . . "DROP
"       DUP"                 BL "P@ COUNT   (PARSE) CR ROT . SWAP . . "DROP
"          "                 BL "P@ COUNT   (PARSE) CR ROT . SWAP . . "DROP
" 1"                         BL "P@ COUNT   (PARSE) CR ROT . SWAP . . "DROP
""                           BL "P@ COUNT   (PARSE) CR ROT . SWAP . . "DROP
.THEN

: REMAINING ( -- addr cnt )    TIB #TIB @ >IN @ /STRING ;

\  : skip ( addr0 len0 char -- addr1 len1 )   >r
\     BEGIN  dup
\     WHILE  over c@ r@ = WHILE  1- swap 1+ swap
\     REPEAT  rdrop ;

\  : scan ( addr0 len0 char -- addr1 len1 )   >r
\     BEGIN  dup
\     WHILE  over c@ r@ - WHILE  1- swap 1+ swap
\     REPEAT  rdrop ;

\  : /string ( addr0 len0 +n -- addr1 len1 )
\     over umin rot over + -rot - ;

: PARSE ( c -- addr +n )   REMAINING (PARSE) >IN +! ;

: CAPITAL  ( char1 -- char2 )  >BYTE DUP 061 07B WITHIN 0=EXIT  BL XOR ;

: ?CAPITALIZE  ( string -- string )
   CAPS @ 0=EXIT  DUP COUNT BOUNDS ?DO  I @ CAPITAL I !  LOOP ;

: TAKE ( c -- string )  \ next textstring nach TOKEN
   TOKEN SWAP PARSE 064 MIN PLACE
   BL TOKEN AFTER C!  TOKEN ?CAPITALIZE ; SYS

: WORD ( c <ccc> -- addr )  \ word nach HERE
   HERE SWAP PARSE 0255 MIN PLACE HERE
   BL OVER AFTER C! ;

VARIABLE 'UNKNOWN   ' DOWNLOAD_ERROR 'UNKNOWN !

: ?KNOWN ( token.addr f -- )
   ?EXIT  RS232_SEMA LOCK
   SPACE  COUNT TYPE ."  ?"
   STATE @ IF  CLEAR  THEN
   'UNKNOWN @ EXECUTE ; SYS

\ --- Zahlenkonvertierung Eingabe

: DIGIT> ( ps: c n1 ===> n2 ?t | c ?f )
   SWAP DUP ':' 'A' WITHIN 0= OVER '/' > AND
   IF                                           \ Ziffernsymbol oder Buchstabe
      DUP '@' > IF  7 -  THEN                   \ Buchstabenkorrektur
          '0' - DUP ROT <  EXIT
   THEN  NIP FALSE; ; SYS

: CONVERT ( ud1 addr1 ===> ud2 addr2 )
   BEGIN   1+ DUP >R C@ BASE @ DIGIT>
   WHILE   PAUSE SWAP  BASE @ UM* DROP ROT BASE @ UM* D+ R>
   REPEAT  DROP R> ;

\ konvertiert counted string ab addr, der mit einem )
\ Leerzeichen abgeschlossen sein mu, in Wert w )
\ das count-Byte wird nicht bercksichtigt )

DECIMAL -HEADER

: SETBASE  ( addr -- addr' base )
   DUP C@
   '$' CASE? IF  016  EXIT THEN
   '&' CASE? IF  010  EXIT THEN
   '%' CASE? IF    2  EXIT THEN
   DROP  1- BASE @; ;

+HEADER

: NUMBER? ( string -- string ?f | w ?t )
   BASE @ >R
   DUP 1+ DUP C@ '-' = IF  1+  THEN     \ das erste Zeichen ist '-'
   SETBASE BASE !  1+
   DUP C@ BASE @ DIGIT>                 \ ist das erste Zeichen konvertierbar
   IF  0 ROT CONVERT C@ BL =            \ das erste nicht konvertierbare Zeichen ist ein Leerzeichen
      IF  DROP SWAP 1+ C@ '-' = IF  NEGATE  THEN  \ Vorzeichenkorrektur
          TRUE R> BASE !  EXIT          \ hier erfolgreich aussteigen
      THEN
   THEN                                 \ hier ohne Erfolg aussteigen
   2DROP FALSE
   R> BASE !; ;


